<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/unwinding-0.1.4/src/arch.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>arch.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../unwinding/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../unwinding/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../unwinding/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
</pre><pre class="rust"><code><span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">x86_64</span> {
    <span class="kw">use</span> <span class="ident">gimli</span>::{<span class="ident">Register</span>, <span class="ident">X86_64</span>};

    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Arch</span>;

    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
    <span class="kw">impl</span> <span class="ident">Arch</span> {
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SP</span>: <span class="ident">Register</span> <span class="op">=</span> <span class="ident">X86_64::RSP</span>;
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">RA</span>: <span class="ident">Register</span> <span class="op">=</span> <span class="ident">X86_64::RA</span>;

        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNWIND_DATA_REG</span>: (<span class="ident">Register</span>, <span class="ident">Register</span>) <span class="op">=</span> (<span class="ident">X86_64::RAX</span>, <span class="ident">X86_64::RDX</span>);
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNWIND_PRIVATE_DATA_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">6</span>;
    }
}
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">x86_64</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">x86</span> {
    <span class="kw">use</span> <span class="ident">gimli</span>::{<span class="ident">Register</span>, <span class="ident">X86</span>};

    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Arch</span>;

    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
    <span class="kw">impl</span> <span class="ident">Arch</span> {
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SP</span>: <span class="ident">Register</span> <span class="op">=</span> <span class="ident">X86::ESP</span>;
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">RA</span>: <span class="ident">Register</span> <span class="op">=</span> <span class="ident">X86::RA</span>;

        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNWIND_DATA_REG</span>: (<span class="ident">Register</span>, <span class="ident">Register</span>) <span class="op">=</span> (<span class="ident">X86::EAX</span>, <span class="ident">X86::EDX</span>);
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNWIND_PRIVATE_DATA_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">5</span>;
    }
}
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">x86</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;riscv64&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;riscv32&quot;</span>))]</span>
<span class="kw">mod</span> <span class="ident">riscv</span> {
    <span class="kw">use</span> <span class="ident">gimli</span>::{<span class="ident">Register</span>, <span class="ident">RiscV</span>};

    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Arch</span>;

    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
    <span class="kw">impl</span> <span class="ident">Arch</span> {
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SP</span>: <span class="ident">Register</span> <span class="op">=</span> <span class="ident">RiscV::SP</span>;
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">RA</span>: <span class="ident">Register</span> <span class="op">=</span> <span class="ident">RiscV::RA</span>;

        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNWIND_DATA_REG</span>: (<span class="ident">Register</span>, <span class="ident">Register</span>) <span class="op">=</span> (<span class="ident">RiscV::A0</span>, <span class="ident">RiscV::A1</span>);
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNWIND_PRIVATE_DATA_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">2</span>;
    }
}
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;riscv64&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;riscv32&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">riscv</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">aarch64</span> {
    <span class="kw">use</span> <span class="ident">gimli</span>::{<span class="ident">AArch64</span>, <span class="ident">Register</span>};

    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Arch</span>;

    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
    <span class="kw">impl</span> <span class="ident">Arch</span> {
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SP</span>: <span class="ident">Register</span> <span class="op">=</span> <span class="ident">AArch64::SP</span>;
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">RA</span>: <span class="ident">Register</span> <span class="op">=</span> <span class="ident">AArch64::X30</span>;

        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNWIND_DATA_REG</span>: (<span class="ident">Register</span>, <span class="ident">Register</span>) <span class="op">=</span> (<span class="ident">AArch64::X0</span>, <span class="ident">AArch64::X1</span>);
        <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNWIND_PRIVATE_DATA_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">2</span>;
    }
}
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">aarch64</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">any</span>(
    <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>,
    <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86&quot;</span>,
    <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;riscv64&quot;</span>,
    <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;riscv32&quot;</span>,
    <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>
)))]</span>
<span class="macro">compile_error!</span>(<span class="string">&quot;Current architecture is not supported&quot;</span>);
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="unwinding" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>